<?php
/**
* Joomla Community Builder User Plugin: plug_geommunitylocator extended
* @author Adrien Roussel
* @copyright (C) www.nordmograph.com
* @license GNU/GPL v3
*/
if ( ! ( defined( '_VALID_CB' ) || defined( '_JEXEC' ) || defined( '_VALID_MOS' ) ) ) { die( 'Direct Access to this location is not allowed.' ); }
class getGeommunityLocatorTabClass extends cbTabHandler
{
	function getGeommunityLocatorTab()
	{
		$this->cbTabHandler();
	}
	/**
        * Generates the HTML to display the registration tab/area
        * @param object tab reflecting the tab database entry
        * @param object mosUser reflecting the user being displayed (here null)
        * @param int 1 for front-end, 2 for back-end
        * @return mixed : either string HTML for tab content, or false if ErrorMSG generated
        */
	function getDisplayRegistration($tab, $user, $ui , $postdata)
	{
		$params 		= $this->params;
		$readonly 		= $params->get('readonly',0);
		$registration 	= $params->get('registration',1);
		if($registration && !$readonly)
			return $this->getDisplayReg($tab,$user,$ui);
    }
        
        /**
        * Saves the registration tab/area postdata into the tab's permanent storage
        * @param object tab reflecting the tab database entry
        * @param object mosUser reflecting the user being displayed (here null)
        * @param int 1 for front-end, 2 for back-end
        * @param array _POST data for saving edited tab content as generated with getEditTab
        * @return mixed : either string HTML for tab content, or false if ErrorMSG generated
        */
	function saveRegistrationTab($tab, &$user, $ui, $postdata)
	{
		$params 		= $this->params;
		$readonly 		= $params->get('readonly',0);
		$registration 	= $params->get('registration',1);
		if($registration && !$readonly)
            $this->_saveLocatorInfo( $user , true );
	}
	
	
	
	
	
	function _saveLocatorInfo( $user , $insert = false )
	{
		global $_CB_framework,$_CB_database, $_REQUEST;
		$db = $_CB_database;
		$params = $this->params;
		$readonly = $params->get('readonly',0);
		$registration = $params->get('registration',1);
		if ( $insert)
		{
			if ( $_REQUEST['cb_geolat'] !='0' && $_REQUEST['cb_geolng'] !='0')
			{
				$query ="UPDATE #__comprofiler 
				SET cb_geolat='".$_REQUEST['cb_geolat']."',cb_geolng='".$_REQUEST['cb_geolng']."' 
				WHERE id='".$user->id."'";
				$db->setQuery($query);
            	$db->query();
			}
		}	
	}
	function getDisplayReg($tab,$user,$ui)
	{ // show at registration
		JHtml::_('bootstrap.tooltip');
		global $_CB_framework,$_CB_database;
		$juri 			= $_CB_framework->getCfg( 'live_site' );
		$doc			= JFactory::getDocument();
		
		$doc->addStyleSheet( $juri.'/components/com_comprofiler/plugin/user/plug_geommunitylocator/css/style.css');
		$doc->addStyleSheet($juri.'/components/com_geommunity3cb/assets/css/fontello.css');

		$db = $_CB_database;
		$lang =$_CB_framework->getCfg( 'lang' );
		$absolute_path = $_CB_framework->getCfg( 'absolute_path' );		
		$languagePath=$absolute_path.'/components/com_comprofiler/plugin/user/plug_geommunitylocator';
		if (file_exists($languagePath.'/language/'.$lang.'.php'))
		  include_once($languagePath.'/language/'.$lang.'.php');
		else include_once($languagePath.'/language/english.php');
		$marker='';
		$params 			= $this->params;
		$type 				= $params->get('regtype');
		$stylez				= $params->get('stylez');
		$width 				= $params->get('regwidth','100%');
		$height 			= $params->get('regheight','400px');
		$zoom 				= $params->get('regzoom','2');
		$scrollwheel 		= $params->get('regscrollwheel',1);
		$showstreetview 	= $params->get('showstreetview',1);
		$browsergeo_reg 	= $params->get('browsergeo_reg',1);
		if($scrollwheel)
			$scrollwheel='true';
		else
			$scrollwheel='false';
      	$lat 				= $params->get('reglat','0');
      	$lng 				= $params->get('reglng','0');
		
		// component params
		$cparams 			= JComponentHelper::getParams('com_geommunity3cb');
		//$unitsystem			= $cparams->get('unitsystem','METRIC');
		$js_apikey			= $cparams->get('js_apikey');  
		$js_client			= $cparams->get('js_client'); 	
		$js_signature		= $cparams->get('js_signature');

		
	
	
		$api_url= '//maps.googleapis.com/maps/api/js?key='.$js_apikey;
		if($js_client !='' && $js_signature !='' )
			$api_url .= '&client='.$js_client.'&signature='.$js_signature;		
		$doc->addScript( $api_url );

		$appfiles_path 		="/components/com_comprofiler/plugin/user/plug_geommunitylocator/img/";
		$html 				='';
		$mapscript ="function add_Event(obj_, evType_, fn_){ 
						if (obj_.addEventListener)
							obj_.addEventListener(evType_, fn_, false); 
						else
							obj_.attachEvent('on'+evType_, fn_);  
					}
					var map ;
					var infobulle_moved;
    			function initializemap(){
						var latlng = new google.maps.LatLng(".$lat.",".$lng.");
						var myOptions = {
							zoom: ".$zoom.",
							center: latlng,
							mapTypeId: google.maps.MapTypeId.".$type.",
							scrollwheel: ".$scrollwheel.",
							navigationControl: true,
							scaleControl: true,
							mapTypeControl: true,
							streetViewControl: ".$showstreetview."
						}
						 map = new google.maps.Map(document.getElementById('map'), myOptions);
						var me = new google.maps.LatLng(255,255);
							var marker = new google.maps.Marker({						
								position: me,
								map: map,
								clickable: true,
								draggable: true
							});
						
						google.maps.event.addListener(map, 'click', function(event) {
							var PointTmp2 = event.latLng;
							marker.setPosition(PointTmp2);
							document.adminForm.cb_geolat.value = event.latLng.lat();
							document.adminForm.cb_geolng.value = event.latLng.lng();
						});";
						
						if($stylez!='')
						{
							$mapscript .="var stylez = ".$stylez.";
							var styledMapOptions = {
								name: '1'
							}
							var GeommunityLocatorMapType = new google.maps.StyledMapType( stylez, styledMapOptions);
							map.mapTypes.set('1', GeommunityLocatorMapType);
							map.setMapTypeId('1');";	
						}
						
						$mapscript .="google.maps.event.addListener(marker, 'dragend', function() {
						var PointTmp = marker.getPosition();
						marker.setPosition(PointTmp);
						document.adminForm.cb_geolat.value = PointTmp.lat();
						document.adminForm.cb_geolng.value = PointTmp.lng();
									
						infobulle_moved.open(map,marker);
						
					});";
				if($browsergeo_reg) $mapscript .="updategmap(map , marker );";
						
						
				$mapscript .="}";
		
		if($browsergeo_reg){
			
		  		$mapscript .="function updategmap(map , marker ){
				 			navigator.geolocation.getCurrentPosition(function(position) {							   
								document.getElementById('cb_geolat').value = position.coords.latitude;
								document.getElementById('cb_geolng').value = position.coords.longitude;
								var guessed = new google.maps.LatLng(position.coords.latitude, position.coords.longitude);
								map.setCenter(guessed);
								
								marker.setPosition( guessed );
								infobulle_moved = new google.maps.InfoWindow({
									content:'"._GL_PRESSREGISTER."'
								});
								
								infobulle_moved.open(map,marker);
								google.maps.event.addListener(marker,'click',function(event){
									infobulle_moved.open(map, marker);
								});
								
								google.maps.event.addListener(marker, 'mousedown', function() {
									infobulle_moved.close();											   
								});
								google.maps.event.addListener(marker, 'mouseup', function() {
										infobulle_moved.open(map,marker);											   
								});
																  
								google.maps.event.addListener(marker, 'dragend', function() {
									var PointTmp = marker.getPosition();
									marker.setPosition(PointTmp);
									document.getElementById('cb_geolat').value = PointTmp.lat();
									document.getElementById('cb_geolng').value = PointTmp.lng();						
									
								 });
								google.maps.event.addListener(map, 'click', function(event) {
									var PointTmp2 = event.latLng;
									marker.setPosition(PointTmp2);
									document.getElementById('cb_geolat').value = event.latLng.lat();
									document.getElementById('cb_geolng').value = event.latLng.lng();
													
																		
								});
							});
			 		
			 			}";
			}
			
			$mapscript .=" function initgmap() {
      			arguments.callee.done = true;
      			initializemap();
    		}
    		add_Event(window, 'load', initgmap);";
$doc->addScriptDeclaration($mapscript);
		$html .='<tr><td class="titleCell"> <label >'._GL_POINTLOCATION.'</label></td><td class="fieldCell"><div style="text-align:right;"><a href="javascript:initgmap();" class="btn btn-small hasTooltip" title="'._GL_RESETMAP.'"><span class="geom-icon-loop "></span></a></div></td></tr>
					<tr><td colspan=2 ><div id="map" style="height:'.$height.';width:100%;">
						<div style="text-align:center;"><br /><br /><br /><img src="'.$juri.'/components/com_comprofiler/plugin/user/plug_geommunitylocator/img/loader.gif" title="Geommunity" alt="Geommunity" width="16" height="11" /></div>
					</div>
		<input type="hidden" id="cb_geolat" name="cb_geolat" readonly/>
		<input type="hidden" id="cb_geolng" name="cb_geolng" readonly/>
		
		';
		
		$html .='</td>';

		return '<table width="100%">'.$html.'</table>';
		
	}
	
	function getEditTab( $tab, $user, $ui)
	{
		global $_CB_framework;
		$lang =$_CB_framework->getCfg( 'lang' );
		$absolute_path = $_CB_framework->getCfg( 'absolute_path' );		
		$languagePath=$absolute_path.'/components/com_comprofiler/plugin/user/plug_geommunitylocator';
		if (file_exists($languagePath.'/language/'.$lang.'.php'))
		  include_once($languagePath.'/language/'.$lang.'.php');
		else include_once($languagePath.'/language/english.php');
		$params = $this->params;
		$browsergeo_pedit = $params->get('browsergeo_pedit',1);
		$readonly = $params->get('readonly',0);
		
		$juser = JFactory::getUser();
		$html='';
		if($browsergeo_pedit && $juser->id == $user->id && !$readonly)
		{
			$html .='<script  type="text/javascript">
						if (navigator.geolocation) {
							navigator.geolocation.getCurrentPosition(function(position) {
								document.getElementById(\'cb_geolat\').value = position.coords.latitude;
								document.getElementById(\'cb_geolng\').value = position.coords.longitude;
							});
						}</script>';
		}
		return $html;
	}

	function getDisplayTab($tab,$user,$ui) {
		JHtml::_('bootstrap.tooltip');
		global $_CB_framework,$_CB_database,$ueConfig;
		$doc			= JFactory::getDocument();
		$jinput		= JFactory::getApplication()->input;
		$juri = $_CB_framework->getCfg( 'live_site' );
		$db = $_CB_database;
		$lang =$_CB_framework->getCfg( 'lang' );
		$absolute_path = $_CB_framework->getCfg( 'absolute_path' );
		$my_id = $_CB_framework->myId();
		$userid = $user->id;
		$html ='';
		$doc->addStyleSheet( $juri.'/components/com_comprofiler/plugin/user/plug_geommunitylocator/css/style.css');
		$doc->addStyleSheet($juri.'/components/com_geommunity3cb/assets/css/fontello.css');

		$languagePath=$absolute_path.'/components/com_comprofiler/plugin/user/plug_geommunitylocator';
		if (file_exists($languagePath.'/language/'.$lang.'.php'))
		  include_once($languagePath.'/language/'.$lang.'.php');
		else include_once($languagePath.'/language/english.php');
		$appfiles_path ="/components/com_comprofiler/plugin/user/plug_geommunitylocator/img/";
		
		include_once JPATH_ADMINISTRATOR . '/components/com_comprofiler/plugin.foundation.php';
		if($ueConfig['name_format']=='1' || $ueConfig['name_format']=='2')
			$fnaming 	= 'name';
		else
			$fnaming 	= 'username';
	
	
		$params = $this->params;
		$readonly = $params->get('readonly',0);
		
		$mymarker = '';
		$friendsmarkers = '';
		$friendspolylines ='';
		
		$type = $params->get('type');
		$width = $params->get('width','100%');
		$height = $params->get('height','400px');
		$zoom = $params->get('zoom','5');
		$minzoom = $params->get('minzoom','1');
		$maxzoom = $params->get('maxzoom','20');
		$browsergeo_pfront = $params->get('browsergeo_pfront',0);
		$scrollwheel = $params->get('scrollwheel',1);
		if($scrollwheel) $scrollwheel='true';
		else $scrollwheel='false';
		$modulelink = $params->get('modulelink','index.php');
		$showfriends = $params->get('showfriends',1);
		$showstreetview = $params->get('showstreetview',1);
		$showqrcode = $params->get('showqrcode',1);
		$friendslimit = $params->get('friendslimit',100);
		$linecolor = $params->get('linecolor','#333333');
		$stylez = $params->get('stylez');
		
		$showroute			= $params->get( 'showroute',1 );
		$enable_modeoftravel = $params->get( 'enable_modeoftravel',1 );
		$default_modeoftravel = $params->get( 'default_modeoftravel','DRIVING' );

		// component params
		$cparams 			= JComponentHelper::getParams('com_geommunity3cb');
		$unitsystem			= $cparams->get('unitsystem','METRIC');
		$js_apikey			= $cparams->get('js_apikey');  
		$js_client			= $cparams->get('js_client'); 	
		$js_signature		= $cparams->get('js_signature');
		

		$user_username = ucfirst($user->$fnaming);
		
		if($my_id == $userid && !$readonly)
			$html ='<div><form name="Form" method="post" action="'.cbSef('index.php?option=com_comprofiler').'#geommunity_plugin">';
			
		$newlat= $jinput->post->get('cb_geolat');
		$newlng= $jinput->post->get('cb_geolng');
		
		if ($newlat!='' && $newlng!=''  && $my_id == $userid && $my_id != 0 && !$readonly) {
			$query ="UPDATE #__comprofiler SET cb_geolat='".$newlat."',cb_geolng='".$newlng."' WHERE id='".$my_id."'";
			$db->setQuery($query);
			if (!$db->query()) die($db->stderr(true));
		}

    	if ( 	($user->cb_geolng!=""
					&& $user->cb_geolat!="" 
					&& is_numeric($user->cb_geolat) 
					&& is_numeric($user->cb_geolng)
				)||( $newlat!='')
			)
		{
      		$lat = $user->cb_geolat;
			$lng = $user->cb_geolng;

			if ($newlat!='')
			{
				$lat = $newlat;
				$lng = $newlng;
			}

				
			if ($my_id == $user->id && $lat!='' && $lng!='' && !$readonly)
			{
				$mymarker = "var me = new google.maps.LatLng($lat,$lng);
				var marker = new google.maps.Marker({						
				position: me,
				map: map,
				clickable: true,
				draggable: true,					
				title:'".$user_username."',
			});
			var infobulle = new google.maps.InfoWindow({
				content:'<div class=\'bg-warning\'><span class=\'geom-icon-info\'></span> "._GL_CLICKAPLACE;
			if($browsergeo_pfront)
			{
				$mymarker .= " "._GL_ORASK." <span class=\'geom-icon-location\'></span>";
			}
			$mymarker .="</div>',
			});
			var infobulle_moved = new google.maps.InfoWindow({
				content:'"._GL_PRESSBUTTON." ";
			
			$mymarker .="<div><input type=\'submit\' name=\'geobutton\' id=\'geobutton\' class=\'btn btn-primary btn-small\' value=\'"._GL_UPDATEBUTTON."\' /></div>'
			});
			google.maps.event.addListener(marker,'click',function(){
				if(moves == 0){
					infobulle.open(map, marker);
				}
				else{
					infobulle_moved.open(map, marker);
				}
			});
			infobulle.open(map,marker);
			
			
			
			google.maps.event.addListener(marker, 'mousedown', function() {
				infobulle.close();	
				infobulle_moved.close();	
			});
			google.maps.event.addListener(marker, 'dragstart', function() {
				deleteOverlays();	
			});											  
			google.maps.event.addListener(marker, 'dragend', function() {
				var PointTmp = marker.getPosition();
			  	marker.setPosition(PointTmp);
				document.Form.cb_geolat.value = PointTmp.lat();
    			document.Form.cb_geolng.value = PointTmp.lng();
				deleteOverlays();				
				infobulle_moved.open(map,marker);
				if ( friendspositionsArray) {								
					for (i=0; i < friendspositionsArray.length; i++) {
						var mepolyline	= new google.maps.LatLng(PointTmp.lat(), PointTmp.lng());
						var friendpolyline	= friendspositionsArray[i];
						var polyline = new google.maps.Polyline({
  							path: [mepolyline,friendpolyline],
							geodesic: 1,
							map:map,
							strokeColor: '".$linecolor."',
							strokeWeight: 1,
							strokeOpacity:1.0
						});
						markersArray.push( polyline );
					}
				}
			});";
			if ($my_id == $userid && $lat=='' && $lng=='' && !$readonly)
			{
				$mymarker ='';
				$lat = '0';
      			$lng = '0';
				$zoom = '2';
			}
				
			}
			if ($my_id == $user->id && $lat=='' && $lng=='' && !$readonly)
			{
				$marker ='';
				$lat = $params->get('lat','0');
				$lng = $params->get('lng','0');
				$zoom = $params->get('zoom','2');
			}
			
			if($showfriends)
			{
				 $q="SELECT m.*,u.name,u.email,u.username,c.avatar,c.avatarapproved, u.id 
				  FROM #__comprofiler_members AS m 
				  JOIN #__comprofiler AS c ON m.memberid=c.id 
				  JOIN #__users AS u ON m.memberid=u.id 
				  WHERE m.referenceid=" . (int) $user->id . " 
				  AND c.confirmed=1 AND c.banned=0 AND u.block=0 
				  AND m.pending=0 AND m.accepted=1 
				  ORDER BY  m.memberid ASC 
				  LIMIT ".$friendslimit;
				$db->setQuery($q);
				$friends = $db->loadObjectList();
				
				$friendsmarkers .=" var friendicon= new google.maps.MarkerImage('".$juri.$appfiles_path."friend.png'); ";	
			
				foreach ($friends as $friend)
				{
					$fid=$friend->id;
					$q= "SELECT cb_geolat, cb_geolng FROM #__comprofiler  WHERE id='".$fid."' AND cb_geolat !=''  AND cb_geolng !='' ";			
					$db->setQuery($q);
     				$coordz = $db->loadRow();
      		 		$friend_cb_geolat = $coordz[0];
     		 		$friend_cb_geolng = $coordz[1];
					if($coordz[0]!='' && $coordz[1]!='')
					{
						$friend->$fnaming;
						$thumb = "/images/comprofiler/tn".$friend->avatar;
						if(!$friend->avatar)
						 	$thumb= "/components/com_comprofiler/plugin/templates/default/images/avatar/tnnophoto_n.png";
						if($friend->avatarapproved=='0')
							$thumb= "/components/com_comprofiler/plugin/templates/default/images/avatar/tnpending_n.png";	
							
						$friendurl = cbSef("index.php?option=com_comprofiler&task=userProfile&user=".$fid);	
						
						
						
						$friendsmarkers .="var friend".$fid." = new google.maps.LatLng(".$friend_cb_geolat.",".$friend_cb_geolng.");
							var fmarker".$fid."= new google.maps.Marker({
								position: friend".$fid.",
								map:map,
								clickable: true,
								title:'".$friend->$fnaming."',
								icon: friendicon
							});";
							if ($my_id == $userid && !$readonly)
								$friendsmarkers .="friendspositionsArray.push( friend".$fid." );";
							$friendsmarkers .="var finfobulle".$fid." = new google.maps.InfoWindow({
								content:'<div><a href=\"".$friendurl."\"> <img width=\"50\" src=\"".$juri.$thumb."\" alt=\"".$friend->$fnaming."\" /></a><div><a href=\"".$friendurl."\"><b>".$friend->$fnaming."</b></a></div>";
								
							if ($my_id == $userid)
								$friendsmarkers .="<div><a class=\"btn btn-small\" onclick=\"javascript:calcFriendRoute(".$friend_cb_geolat.",".$friend_cb_geolng.");\" href=\"#geommunity_plugin\">"._GL_GETDIR."</a></div>";
							
							$friendsmarkers .="</div>'
							});
							new google.maps.event.addListener(fmarker".$fid.",'click',function(){
								finfobulle".$fid.".open(map, fmarker".$fid.");
							});";
							$friendspolylines .="var mepolyline	= new google.maps.LatLng($lat, $lng);	
							var friend".$fid."polyline	= new google.maps.LatLng($friend_cb_geolat, $friend_cb_geolng);
							var polyline".$fid." = new google.maps.Polyline({
								path: [mepolyline,friend".$fid."polyline],
								geodesic: 1,
								map:map,
								strokeColor: '".$linecolor."',
								strokeWeight: 1,
								strokeOpacity:1.0
							});";
							if ($my_id == $userid && !$readonly)
								$friendspolylines .=" markersArray.push( polyline".$fid." );";
						
						
					
					}
				}		
			}
    	}
		else
		{
      		$lat = $params->get('lat','0');
			$lng = $params->get('lng','0');
			$zoom = $params->get('zoom','2');
    	}

		$mapscript ="function add_Event(obj_, evType_, fn_){ 
							if (obj_.addEventListener)
								obj_.addEventListener(evType_, fn_, false); 
							else
								obj_.attachEvent('on'+evType_, fn_);  
						}
						
						
						function calcRoute(visi_lat,visi_lng,modeoftravel) {
							document.getElementById('routelat').value = visi_lat;
						document.getElementById('routelng').value = visi_lng;
				var start;
				if(!modeoftravel )
				modeoftravel = document.getElementById('mode').value;
		
				if(".$my_id."!=0 && visi_lat!=0 && visi_lat!=255 && visi_lng!=0 && visi_lng!=255){
					start	=new google.maps.LatLng(visi_lat,visi_lng);
					var end		=new google.maps.LatLng(".$lat.",".$lng.");
							var request = {
							  origin: start,
							  destination: end,
							  unitSystem: google.maps.DirectionsUnitSystem.".$unitsystem.",
							 travelMode: google.maps.DirectionsTravelMode[modeoftravel]
						};
						
						directionsService.route(request, function(response, status) {
					  if (status == google.maps.DirectionsStatus.OK) {
						document.getElementById('directionspanel').style.display='block';
						directionsDisplay.setDirections(response);
					  }
					  else
					  				alert('"._GL_NOROUTEDATA."');
					});
				}
				else{
					alert('"._GL_APPROXROUTE."');
					
					
					if( navigator.geolocation   ) {
						navigator.geolocation.getCurrentPosition(function(position) {
							start = new google.maps.LatLng(position.coords.latitude,position.coords.longitude);
							var end		=new google.maps.LatLng(".$lat.",".$lng.");
							var request = {
							  origin: start,
							  destination: end,
							 unitSystem: google.maps.DirectionsUnitSystem.".$unitsystem.",
							 travelMode: google.maps.DirectionsTravelMode[modeoftravel]
						};
						
						directionsService.route(request, function(response, status) {
          if (status == google.maps.DirectionsStatus.OK) {
			document.getElementById('directionspanel').style.display='block';
            directionsDisplay.setDirections(response);
          }
		  else
					  				alert('"._GL_NOROUTEDATA."');
        });

						});
						
					}
					
					else{
						alert('"._GL_NOWAY."');
					}			
				}

      }";
	  
	  
	  
	  if($readonly)
	  {
	  	$mapscript .="function calcFriendRoute(friend_lat,friend_lng,modeoftravel) {
						document.getElementById('routelat').value = friend_lat;
						document.getElementById('routelng').value = friend_lng;
						var start;
						if(!modeoftravel )
							modeoftravel = document.getElementById('mode').value;
					
						if(".$my_id."!=0 && friend_lat!=0 &&friend_lat!=255 && friend_lng!=0 && friend_lng!=255){
							var end	=new google.maps.LatLng(friend_lat,friend_lng);
							start		=new google.maps.LatLng(".$lat.",".$lng.");
										var request = {
										  origin: start,
										  destination: end,
										  unitSystem: google.maps.DirectionsUnitSystem.".$unitsystem.",
										 travelMode: google.maps.DirectionsTravelMode[modeoftravel]
									};
									
									directionsService.route(request, function(response, status) {
								  if (status == google.maps.DirectionsStatus.OK) {
									document.getElementById('directionspanel').style.display='block';
									directionsDisplay.setDirections(response);
								  }
								  else
					  				alert('"._GL_NOROUTEDATA."');
							});
						}
				  	}";
					
	}
	  
	  

	  
	 $mapscript .=" var directionsDisplay;
      var directionsService = new google.maps.DirectionsService();
				
				
						
			function initializemap(){
				directionsDisplay = new google.maps.DirectionsRenderer();
				var latlng = new google.maps.LatLng(".$lat.",".$lng.");
				var myOptions = {
					zoom: ".$zoom.",
					minZoom: ".$minzoom.",
					maxZoom: ".$maxzoom.",
					center: latlng,
					mapTypeId: google.maps.MapTypeId.".$type.",
					scrollwheel: ".$scrollwheel.",
					navigationControl: true,
					scaleControl: true,
					mapTypeControl: true,
					streetViewControl: ".$showstreetview."
				}
				var map = new google.maps.Map(document.getElementById('map'), myOptions);
				directionsDisplay.setMap(map);
				directionsDisplay.setPanel(document.getElementById(\"directionspanel\"));
				var me = new google.maps.LatLng($lat,$lng);
				var marker = new google.maps.Marker({						
					position: me,
					map: map,
					clickable: true,					
					title:'".$user_username."'
				});
				
			
				var infobulle = new google.maps.InfoWindow({
				content:'".$user_username." ";
				if($showqrcode)
				{
					 $client = new JApplicationWebClient();
					 if(!$client->mobile)
					 {
					 	$mapscript .="<div title=\'"._GL_QRTITLE."\' class=\'hasTooltip\'><img src=\'//chart.googleapis.com/chart?cht=qr&chs=100x100&chl=geo%3A".$lat."%2C".$lng."\' width=\'100\' height=\'100\' alt=\'Geo QRCode\'/></div>";
					 }
				}
				$mapscript .="'});
				google.maps.event.addListener(marker,'click',function(){
					infobulle.open(map, marker);
				});
				infobulle.open(map,marker);";
				if($stylez!=''){
					$mapscript .="var stylez = ".$stylez.";
					var styledMapOptions = {
						name: \"1\"
					}
					var GeommunityLocatorMapType = new google.maps.StyledMapType( stylez, styledMapOptions);
					map.mapTypes.set(\"1\", GeommunityLocatorMapType);
					map.setMapTypeId(\"1\");";	
				}
				$mapscript .= $friendsmarkers;
				$mapscript .= $friendspolylines;
				$mapscript .="}
				function initgmap() {
      				//if (arguments.callee.done) GUnload();
      				arguments.callee.done = true;
      				initializemap();
    			};
    			add_Event(window, 'load', initgmap);
			";
				
				
				
				
				if ($my_id == $userid && !$readonly)
				{
					$mapscript ="var markersArray = [];
					var friendspositionsArray = [];
					var moves = 0;
					function add_Event(obj_, evType_, fn_){ 
						if (obj_.addEventListener)
							obj_.addEventListener(evType_, fn_, false); 
						else
							obj_.attachEvent('on'+evType_, fn_);  
					}
					function deleteOverlays() {
						if (markersArray) {
							for (i=0; i < markersArray.length; i++) {
								markersArray[i].setMap(null);
							}
							markersArray.length = 0;
						}
					}
					
					
					
					function calcFriendRoute(friend_lat,friend_lng,modeoftravel) {
						document.getElementById('routelat').value = friend_lat;
						document.getElementById('routelng').value = friend_lng;
						var start;
						if(!modeoftravel )
							modeoftravel = document.getElementById('mode').value;
					
						if(".$my_id."!=0 && friend_lat!=0 &&friend_lat!=255 && friend_lng!=0 && friend_lng!=255){
							var end	=new google.maps.LatLng(friend_lat,friend_lng);
							start		=new google.maps.LatLng(document.getElementById('cb_geolat').value,document.getElementById('cb_geolng').value);
										var request = {
										  origin: start,
										  destination: end,
										  unitSystem: google.maps.DirectionsUnitSystem.".$unitsystem.",
										 travelMode: google.maps.DirectionsTravelMode[modeoftravel]
									};
									
									directionsService.route(request, function(response, status) {
								  if (status == google.maps.DirectionsStatus.OK) {
									document.getElementById('directionspanel').style.display='block';
									directionsDisplay.setDirections(response);
								  }
								  else
					  				alert('"._GL_NOROUTEDATA."');
							});
						}
				  	}

					 var directionsDisplay;
      var directionsService = new google.maps.DirectionsService();
					function initializemap(){
						directionsDisplay = new google.maps.DirectionsRenderer();
						var latlng = new google.maps.LatLng(".$lat.",".$lng.");
						var myOptions = {
							zoom: ".$zoom.",
							center: latlng,
							mapTypeId: google.maps.MapTypeId.".$type.",
							scrollwheel: ".$scrollwheel.",
							navigationControl: true,
							scaleControl: true,
							mapTypeControl: true,
							streetViewControl: ".$showstreetview."
						}
						var map = new google.maps.Map(document.getElementById('map'), myOptions);
						directionsDisplay.setMap(map);
				directionsDisplay.setPanel(document.getElementById(\"directionspanel\"));";				
						if($my_id ==$userid && ($lat==0 || $lng==0 || $lat=='' || $lng==''))
						{
							$mapscript .="var me = new google.maps.LatLng(255,255);  //off the map
						var marker = new google.maps.Marker({						
						position: me,
						map: map,
						clickable: true,					
						draggable:true,
						title:'".$user_username."'
						});
						var infobulle = new google.maps.InfoWindow({
							content:''
						});
						var infobulle_moved = new google.maps.InfoWindow({
							content:'"._GL_PRESSBUTTON." <div><input type=\'submit\' name=\'geobutton\' id=\'geobutton\' class=\'button\' value=\'"._GL_UPDATEBUTTON."\' class=\'btn btn-primary btn-small\' /></div>'
						});
						google.maps.event.addListener(marker, 'dragstart', function() {
				deleteOverlays();	
			});											  
			google.maps.event.addListener(marker, 'dragend', function() {
				var PointTmp = marker.getPosition();
			  	marker.setPosition(PointTmp);
				document.Form.cb_geolat.value = PointTmp.lat();
    			document.Form.cb_geolng.value = PointTmp.lng();
				deleteOverlays();				
				infobulle_moved.open(map,marker);
				if ( friendspositionsArray) {								
					for (i=0; i < friendspositionsArray.length; i++) {
						var mepolyline	= new google.maps.LatLng(PointTmp.lat(), PointTmp.lng());
						var friendpolyline	= friendspositionsArray[i];
						var polyline = new google.maps.Polyline({
  							path: [mepolyline,friendpolyline],
							geodesic: 1,
							map:map,
							strokeColor: '".$linecolor."',
							strokeWeight: 1,
							strokeOpacity:1.0
						});
						markersArray.push( polyline );
					}
				}
			});";
						}
			
				
						
						
						$mapscript .="google.maps.event.addListener(map, 'click', function(event) {
							var PointTmp2 = event.latLng;
							marker.setPosition(PointTmp2);
							document.Form.cb_geolat.value = event.latLng.lat();
							document.Form.cb_geolng.value = event.latLng.lng();
							deleteOverlays();
							infobulle.close();
							infobulle_moved.open(map,marker);
							moves ++;
							if ( friendspositionsArray) {								
								for (i=0; i < friendspositionsArray.length; i++) {
									var mepolyline	= new google.maps.LatLng(PointTmp2.lat(), PointTmp2.lng());
									var friendpolyline	= friendspositionsArray[i];
									var polyline = new google.maps.Polyline({
										path: [mepolyline,friendpolyline],
										geodesic: 1,
										map:map,
										strokeColor: '".$linecolor."',
										strokeWeight: 1,
										strokeOpacity:1.0
									});
									markersArray.push( polyline );
								}
							}									
						});";
						if($stylez!='')
						{
							$mapscript .="var stylez = ".$stylez.";
							var styledMapOptions = {
								name: '1'
							}
							var GeommunityLocatorMapType = new google.maps.StyledMapType( stylez, styledMapOptions);
							map.mapTypes.set('1', GeommunityLocatorMapType);
							map.setMapTypeId('1');";	
						}
						$mapscript .= $mymarker;
						$mapscript .= $friendsmarkers;
						$mapscript .= $friendspolylines;
						$mapscript .= "}
					function initgmap() {
						arguments.callee.done = true;
						initializemap();
					};
    				add_Event(window, 'load', initgmap);";
				}
				
				
				
				
				
				
				
				$html .='<a name="geommunity_plugin" id="geommunity_plugin"></a>';
				if($lat !=0 && $lng!=0 && $lat!='' && $lng!=''  || $my_id ==$userid)
				{
					$html .='<table style="width:'.$width.';text-align:left;">';
					$html .='<tr ><td><div style="width:30%;float:left;"><img src="//maps.google.com/intl/en_us/mapfiles/marker.png" alt="Geommunity" width="10" height="17"/> '.ucfirst($user_username).'</div>';
					if($showfriends)
						$html .= '<div style="width:30%;float:left;"><img src="'.$juri.$appfiles_path.'friend.png" alt="'._GL_FRIENDS.'" width="21" height="22"> '._GL_FRIENDS.'</div>';
					
					if ($modulelink !='')
					{
						$html .='<div style="float:right;text-align:right">';
						$html .='<a href="'.$modulelink.'?markerid='.$userid.'#geommunity_module" >
						<span title="'._GL_GLOABALMAP.'" class="hasTooltip badge badge-success">
						<span class="geom-icon-globe"></span></span></a>';
						$html .='</div>';
					}
					if($my_id ==$userid && ($lat==0 || $lng==0 || $lat=='' || $lng==''))
					{
						$html .='<div style="clear:both;">'._GL_CLICKPLACE;
						if($browsergeo_pfront)
						$html .=' '._GL_ORASK.' <a href="javascript:updategmap();"><span class="geom-icon-location"></span></a>';
						$html .='.</div>';
					}
					$html .='</td></tr>';
					$html .='</table>';
					
					$api_url= '//maps.googleapis.com/maps/api/js?key='.$js_apikey;
					if($js_client !='' && $js_signature !='' )
						$api_url .= '&client='.$js_client.'&signature='.$js_signature;		
					$doc->addScript( $api_url );
					
					$doc->addScriptDeclaration($mapscript);
					$html .= "<div id=\"map\" style=\"height:".$height.";width:".$width.";\">";
					$html .= "<div style=\"text-align:center;\"><br /><br /><br /><img src=\"".$juri.$appfiles_path."loader.gif\" alt=\"Geommunity\" title=\"Geommunity\" width=\"16\" height=\"11\" /></div>";
					$html .= "</div>";

					$html .= '<a class="btn btn-small" href="javascript:initgmap();"><span class="geom-icon-loop"></span> '._GL_RESETMAP.'</a>';	
	
					
					if($showroute && $my_id != $userid && $my_id>0)
					{
						$q ="SELECT cb_geolat,cb_geolng FROM #__comprofiler WHERE user_id='".$my_id."' ";
						$db->setQuery($q);
						$visitor_coords = $db->loadRow();
						$visi_lat=$visitor_coords[0];
						$visi_lng=$visitor_coords[1];
						if($my_id==0)
						{
							$visi_lat=0;
							$visi_lng=0;
						}
						$html .='<a class="btn btn-small" onclick="javascript:calcRoute('.$visi_lat.','.$visi_lng.');" ><i class="geom-icon-flag"></i>'._GL_GETDIR.'</a>';
					}
					
					
					if($my_id == $userid && !$readonly)
					{
			 			$browserjs ="function updategmap(){
				 			navigator.geolocation.getCurrentPosition(function(position) {							   
								document.getElementById('cb_geolat').value = position.coords.latitude;
								document.getElementById('cb_geolng').value = position.coords.longitude;
								var guessed = new google.maps.LatLng(position.coords.latitude, position.coords.longitude);
								var myOptions = {
							zoom: 13,
							center: guessed,
							mapTypeId: google.maps.MapTypeId.".$type.",
							scrollwheel: ".$scrollwheel.",
							navigationControl: true,
							scaleControl: true,
							mapTypeControl: true,
							streetViewControl: ".$showstreetview."
						}
						var map = new google.maps.Map(document.getElementById('map'), myOptions);";
						if($stylez!='')
						{
							$browserjs .="var stylez = ".$stylez.";
							var styledMapOptions = {
								name: '1'
							}
							var GeommunityLocatorMapType = new google.maps.StyledMapType( stylez, styledMapOptions);
							map.mapTypes.set('1', GeommunityLocatorMapType);
							map.setMapTypeId('1');";	
						}
						$browserjs .=" deleteOverlays();
						var marker = new google.maps.Marker({						
								position: guessed,
								map: map,
								clickable: true,
								draggable: true,					
								title:'".$user_username."'
						});
						var infobulle_moved = new google.maps.InfoWindow({
							content:'"._GL_PRESSBUTTON." ";						
						$browserjs .="<div><input type=\'submit\' name=\'geobutton\' id=\'geobutton\' class=\'btn btn-primary btn-small\' value=\'"._GL_UPDATEBUTTON."\' /></div>'
						});
						google.maps.event.addListener(marker,'click',function(event){
							infobulle_moved.open(map, marker);
						});
						infobulle_moved.open(map,marker);
						google.maps.event.addListener(marker, 'mousedown', function() {
							infobulle_moved.close();											   
						});
						google.maps.event.addListener(marker, 'mouseup', function() {
								infobulle_moved.open(map,marker);											   
						});
						$friendsmarkers;

						google.maps.event.addListener(marker, 'dragstart', function() {
							deleteOverlays();
						});										  
						google.maps.event.addListener(marker, 'dragend', function() {
							var PointTmp = marker.getPosition();
							marker.setPosition(PointTmp);
							document.Form.cb_geolat.value = PointTmp.lat();
							document.Form.cb_geolng.value = PointTmp.lng();						
							if ( friendspositionsArray) {								
								for (i=0; i < friendspositionsArray.length; i++) {
									var mepolyline	= new google.maps.LatLng(PointTmp.lat(), PointTmp.lng());
									var friendpolyline	= friendspositionsArray[i];
									var polyline = new google.maps.Polyline({
										path: [mepolyline,friendpolyline],
										geodesic: 1,
										map:map,
										strokeColor: '".$linecolor."',
										strokeWeight: 1,
										strokeOpacity:1.0
									});
									markersArray.push( polyline );
								}
							}
						 });
						google.maps.event.addListener(map, 'click', function(event) {
							var PointTmp2 = event.latLng;
							marker.setPosition(PointTmp2);
							document.Form.cb_geolat.value = event.latLng.lat();
							document.Form.cb_geolng.value = event.latLng.lng();
							deleteOverlays();							
							if ( friendspositionsArray) {								
								for (i=0; i < friendspositionsArray.length; i++) {
									var mepolyline	= new google.maps.LatLng(PointTmp2.lat(), PointTmp2.lng());
									var friendpolyline	= friendspositionsArray[i];
									var polyline = new google.maps.Polyline({
										path: [mepolyline,friendpolyline],
										geodesic: 1,
										map:map,
										strokeColor: '".$linecolor."',
										strokeWeight: 1,
										strokeOpacity:1.0
									});
									markersArray.push( polyline );
								}
							}									
						});
						if ( friendspositionsArray) {								
							for (i=0; i < friendspositionsArray.length; i++) {
								var friendpolyline	= friendspositionsArray[i];
								var polyline = new google.maps.Polyline({
									path: [guessed,friendpolyline],
									geodesic: 1,
									map:map,
									strokeColor: '".$linecolor."',
									strokeWeight: 1,
									strokeOpacity:1.0
								});
								markersArray.push( polyline );
							}
						}
			 		})
			 	}";
				$doc->addScriptDeclaration($browserjs);
				if($browsergeo_pfront)
				{
					$html .= '<a href="javascript:updategmap();"><span class="geom-icon-location hasTooltip" title="'._GL_GUESS.'" ></span></a>';
				}
				$html .= '<input type="hidden"  value="'.$lat.'" id="cb_geolat" name="cb_geolat" readonly/>';
				$html .= '<input type="hidden"  value="'.$lng.'" id="cb_geolng" name="cb_geolng"  readonly/>';	
				$html .='</form>';
			}

			
			
			if($showroute)
			{
				$html .='<div id="directionspanel" style="display:none"><hr />';
				$html .='<input type="hidden" id="routelat" name="routelat" /><input type="hidden" id="routelng" name="routelng" />';
				if($enable_modeoftravel){
					$html .='<div id="modeoftravel" style="float:left">';
					if($userid!=$my_id)
						$html .='<select id="mode" onchange="calcRoute('.$visi_lat.','.$visi_lng.',this.value);">';
					elseif($my_id==$userid )
						$html .='<select id="mode" onchange="calcFriendRoute(document.getElementById(\'routelat\').value,document.getElementById(\'routelng\').value,this.value);">';
				  $html .='<option value="DRIVING" ';
				  if($default_modeoftravel=='DRIVING') $html .= 'selected';
				  $html .='>'._GL_DRIVING.'</option>';
				  $html .='<option value="WALKING" ';
				  if($default_modeoftravel=='WALKING') $html .= 'selected';
				  $html .='>'._GL_WALKING.'</option>';
				  $html .='<option value="BICYCLING" ';
				  if($default_modeoftravel=='BICYCLING') $html .= 'selected';
				  $html .='>'._GL_BICYCLING.'</option>';
				$html .='</select></div>';
				}
				else
					$html .='<div id="modeoftravel"><input type="hidden" id="mode" name="mode" value="'.$default_modeoftravel.'" /></div>';
				$html .='<div id="closepanel_top" style="float:right;cursor:pointer">
				<span title="'._GL_CLOSEDIRPANEL.'" onclick="document.getElementById(\'directionspanel\').style.display=\'none\';directionsDisplay.setDirections({routes: []});"" class="geom-icon-cancel" /></span></div>
				<div style="clear:both"></div>';
				
				
				$html .='<div id="closepanel_bot" 
				style="float:right;bottom:5px;right:5px;position:absolute;cursor:pointer">
				<span title="'._GL_CLOSEDIRPANEL.'" onclick="document.getElementById(\'directionspanel\').style.display=\'none\';directionsDisplay.setDirections({routes: []});"" class="icon-cancel" /></span></div>
				<div style="clear:both"></div>';
				$html .='</div>';		
			}	
		}
		else
		{
			$html .='<div><i class="geom-icon-location"></i> <b>'.$user_username.'</b> '._GL_HASNOTYET.'</div>';
		}
		
		if($my_id == $userid && !$readonly)
			$html .='</div>';
		return $html;
	}
}
?>